package main
import "os"

func writeFile(filename string, data [] byte) (error os.Error) {
   // ファイルのオープン
   file, err := os.Open(filename, os.O_CREATE | os.O_WRONLY, 0777)
   if err != nil {
       return err
   }
   // 後処理を遅延実行
   defer func() {
     // ファイルのクローズ
     file.Close()
     // エラーが起きていたときは、ファイルを削除する
     if error != nil {
       os.Remove(filename)
     }
   }()

   // ファイルの書き込み
   _, err = file.Write(data)
   if err != nil {
       return err
   }
   // 正常終了
   return nil
}

func main() {
  d := make([]byte, 5)
  d[0] = 'H'; d[1] = 'E'; d[2] = 'L'; d[3] = 'L'; d[4] = 'O'  
  writeFile("test.txt", d)
}

